/* [Parts] */

// Set "Personalised" and go to the last tab to make your own.
part_type = "Personalised"; // [Extremity, I, T, L, X, Cube_corner, T_corner, Half_star, Star, Tetrahedron_corner, Octahedron_corner, Personalised]

// Edges iteration
edges_iteration = 0; // [0:90°, 1:45° on z, 2:full 45°]

width = 20;

// Set 0 if you want than edge length equals Width.
edge_length = 0;

edge_shape = "sphere"; // [rectangular, circular, sphere]

external_bevel = "none"; // [none, sphere]

/* [Holes] */

// edges hole width size.
hole_width = 10.1;

// What kind of hole do you want ?
edge_hole_shape = "circular"; // [rectangular, circular, none]

main_hole_shape = "none"; // [rectangular, circular, none]

// Difference between the main hole size and the edges hole size.
main_hole_slack = 0;

// Set 0 if you want than edge length equals Width.
edge_hole_deep = 11;

holes_bevel = 0;

/* [Personalised part] */

// Set -1 to disabled this edge.
first_edge_angle = 0; // [-1:180]
first_edge_revolution_angle = 0; // [0:360]

second_edge_angle = 60; // [-1:180]
second_edge_revolution_angle = 0; // [0:360]

third_edge_angle = 90; // [-1:180]
third_edge_revolution_angle = 125.26; // [0:360]

fourth_edge_angle = 120; // [-1:180]
fourth_edge_revolution_angle = 70.52; // [0:360]

fifth_edge_angle = -1; // [-1:180]
fifth_edge_revolution_angle = 0; // [0:360]

sixth_edge_angle = -1; // [-1:180]
sixth_edge_revolution_angle = 0; // [0:360]

seventh_edge_angle = -1; // [-1:180]
seventh_edge_revolution_angle = 0; // [0:360]

eighth_edge_angle = -1; // [-1:180]
eighth_edge_revolution_angle = 0; // [0:360]

nineth_edge_angle = -1; // [-1:180]
nineth_edge_revolution_angle = 0; // [0:360]

tenth_edge_angle = -1; // [-1:180]
tenth_edge_revolution_angle = 0; // [0:360]

eleventh_edge_angle = -1; // [-1:180]
eleventh_edge_revolution_angle = 0; // [0:360]

twelveth_edge_angle = -1; // [-1:180]
twelveth_edge_revolution_angle = 0; // [0:360]

thirdteenth_edge_angle = -1; // [-1:180]
thirdteenth_edge_revolution_angle = 0; // [0:360]

fourteenth_edge_angle = -1; // [-1:180]
fourteenth_edge_revolution_angle = 0; // [0:360]


// Need more edges? Download OpenScad and compile your parts yourself !
sixth_edge_revolution_angle = 0; // [0:360]


print_parts(part_type);

module print_parts(part)
{
	if (part == "Extremity")
		part([[90,0]], type="flat");

	else if (part == "I")
		part([[90,0], [90,180]], type="flat");

	else if (part == "T")
		if (edges_iteration == 0)
			part([[90,0], [90,90], [90,180]], type="flat");
		else
			part([[90,0], [90,45], [90,90], [90,135], [90,180]], type="flat");

	else if (part == "L")
		if (edges_iteration == 0)
			part([[90,0], [90,90]], type="flat");
		else
			part([[90,0], [90,45], [90,90]], type="flat");

	else if (part == "X")
		if (edges_iteration == 0)
			part([[90,0], [90,90], [90,180], [90,270]], type="flat");
		else
			part([[90,0], [90,45], [90,90], [90,135], [90,180], [90,225], [90,270], [90,315]], type="flat");

	else if (part == "Cube_corner")
		if (edges_iteration == 0)
			part([[0,0], [90,0], [90,90]], type="block");
		else if (edges_iteration == 1)
			part([[0,0], [45,0], [90,0], [45,90], [90,90]], type="block");
		else
			part([[0,0], [45,0], [90,0], [45,90], [90,90], [90,45]], type="block");

	else if (part == "T_corner")
		if (edges_iteration == 0)
			part([[0,0], [90,0], [90,90], [90,180]], type="block");
		else if (edges_iteration == 1)
			part([[0,0], [45, 0], [90,0], [45,90], [90,90], [45,180], [90,180]], type="block");
		else
			part([[0,0], [45, 0], [90,0], [45,90], [90,90], [45,180], [90,180], [90,45], [90,135]], type="block");


	else if (part == "Half_star")
		if (edges_iteration == 0)
			part([[0,0], [90,0], [90,90], [90,180], [90, 270]], type="block");
		else if (edges_iteration == 1)
			part([[0,0], [45, 0], [90,0], [45,90], [90,90], [45,180], [90,180], [90,270], [45,270]], type="block");
		else
			part([[0,0], [45, 0], [90,0], [45,90], [90,90], [45,180], [90,180], [90,45], [90,135], [90,270], [45,270], [90,225], [90,315]], type="block");

	else if (part == "Star")
		if (edges_iteration == 0)
			part([[0,0], [90,0], [90,90], [90,180], [90, 270], [180,0]], type="block");
		else if (edges_iteration == 1)
			part([[0,0], [45, 0], [90,0], [45,90], [90,90], [45,180], [90,180], [90,270], [45,270], [180,0], [135,0], [135,90], [135,180], [135,270]], type="block");
		else
			part([[0,0], [45, 0], [90,0], [45,90], [90,90], [45,180], [90,180], [90,45], [90,135], [90,270], [45,270], [90,225], [90,315], [180,0], [135,0], [135,90], [135,180], [135,270]], type="block");
	
	else if (part == "Tetrahedron_corner")
		part([[35.26,0], [35.26,120], [35.26,240]], type="platonic"); // acos(sqrt(6)/3)

	else if (part == "Octahedron_corner")
		part([[45,0], [45, 90], [45,180], [45,270]], type="platonic"); // acos(sqrt(2)/2)

	else if (part == "Personalised")
		part([[first_edge_angle, first_edge_revolution_angle],
			[second_edge_angle, second_edge_revolution_angle],
			[third_edge_angle, third_edge_revolution_angle],
			[fourth_edge_angle, fourth_edge_revolution_angle],
			[fifth_edge_angle, fifth_edge_revolution_angle],
			[sixth_edge_angle, sixth_edge_revolution_angle],
			[seventh_edge_angle, third_edge_revolution_angle],
			[eighth_edge_angle, fourth_edge_revolution_angle],
			[nineth_edge_angle, third_edge_revolution_angle],
			[tenth_edge_angle, third_edge_revolution_angle],
			[eleventh_edge_angle, fourth_edge_revolution_angle],
			[twelveth_edge_angle, fourth_edge_revolution_angle],
			[thirdteenth_edge_angle, third_edge_revolution_angle],
			[fourteenth_edge_angle, fourth_edge_revolution_angle]]);
}

module part(v, type)
{
	$fn = 50;
	edge_length = (edge_length < width) ? width : edge_length;
	hole_width = (hole_width >= width) ? width-1 : hole_width;
	main_hole_width = hole_width + main_hole_slack;
	edge_hole_deep = (edge_hole_deep <=0) ? edge_length : edge_hole_deep;
	
	translate([0,0,width/2]) intersection() {
		if (external_bevel == "sphere") 
			sphere(edge_length);

		difference() {
			if (edge_shape == "sphere") {
				sphere(edge_length);
			} else {
				union() {
					if (edge_shape == "circular")
						sphere(width/2);
					if (edge_shape == "rectangular" && type == "block")
						cube(width, center=true);
					else if (type == "flat")
						cylinder(h=width, r=width/2, center=true);
					for(i = [0:len(v)-1]) {
						if (v[i][0] != -1)
							rotate([v[i][0], 0, v[i][1]]) {
								block(width, edge_length, edge_shape);
						}
					}
				}
			}
	
			for(i = [0:len(v)-1]) {
				if (v[i][0] != -1)
					rotate([v[i][0], 0, v[i][1]]) {
						translate([0, 0, edge_length - edge_hole_deep + 0.1])
							block(hole_width, edge_hole_deep, edge_hole_shape, bevel = "int");
							if (edge_shape == "rectangular" && type == "platonic")
								translate([0, -width*0.75 + 0.1, 0])
									cube([width+1, width/2, edge_length*2], center=true);
				}
			}

			block(main_hole_width, width+1, main_hole_shape);
		}
	}
}

module block(block_width, length, shape, bevel)
{
	length = (length == 0) ? width : length;
	translate ([0, 0, length/2-0.1]) {
		if (shape=="rectangular")
			cube([block_width, block_width, length], center=true);
		else if (shape=="circular")
			cylinder(r=block_width/2, h=length, center=true);
		else if (shape=="hexagonal")
			rotate([0,0,22.5]) cylinder(r=block_width/2, h=length, center=true, $fn=8);
		echo(bevel);

		if (bevel == "int")
			translate([0, 0, length/2 - block_width/2]) rotate([0,0,45])
				cylinder(r1=0, r2 = (edge_hole_shape == "rectangular") ? block_width*0.707 + holes_bevel : block_width/2 + holes_bevel, h=block_width/2, $fn = (edge_hole_shape == "rectangular") ? 4 : $fn);
		else if (bevel == "ext")
			echo("ext");
	}
}
